package handles;

public class Handles {

	static class A {
		void saySth() {
			System.out.println("Hello from a call back");
		}
	}

	static class NativeHandleOverTime {
		static {
			System.load("Handles$NativeHandleOverTime_impl.so");
		}

		native void swallowObject(A a);

		native void giveItFree();
	}

	public static void main(String[] args) throws InterruptedException {
		NativeHandleOverTime nativeHandle = new NativeHandleOverTime();
		A a = new A();

		nativeHandle.swallowObject(a);

		Thread.sleep(2 * 1000);
		System.out.println("sleeping over");
		nativeHandle.giveItFree();
	}

}
